#!/bin/bash
#set -x

CLIENT_LIST="`pwd`/client.list"
OPTIONS="hc:"
RESULT_FILE="/tmp/ping_answer.txt"

usage(){
	echo
	echo "Использование: $0 [-$OPTIONS]"
	echo
	echo "	h	- help, помощь"
	echo "	c file	- clients, список клиентов, умолчание $CLIENT_LIST"
	echo
}


init_prog(){
	while getopts $OPTIONS opt
	do
		case $opt in
		h ) usage; exit 0;;
		c ) CLIENT_LIST=$OPTARG;;
		\?) exit 1;;	# Оброботка ошибок getopts
#		* ) usage; exit 1;;
		esac
	done
}


ping_clients()
{
declare -a client_state

if [ ! -f $CLIENT_LIST ]
then
	echo "No client list file found $CLIENT_LIST"
	exit 1
else
	declare -a client_ip=( `cat $CLIENT_LIST | awk -F'#' '{print $1}' | sed '/^$/d'` )
fi

echo "Опрос клиентов..."

:> $RESULT_FILE	|| exit 1		# Очистка файла

i=0
while [ $i -lt ${#client_ip[@]} ]
do
(
	ping -c 1 ${client_ip[$i]} > /dev/null 2>&1
	if [[ $? == 0 ]]
	then
		client_state[$i]="ping OK"
	else
		client_state[$i]="NO answer"
	fi
	echo "ping ${client_ip[$i]} - ${client_state[$i]}" >> $RESULT_FILE
#	i=$[i+1]
) &
	i=$[i+1]
done

wait
}

print_result()
{
	cat $RESULT_FILE | sort
}

#### MAIN #####

trap "exit 1" 1 2 3 6 15 # Перехват сигналов SIG*
init_prog $@
ping_clients
print_result

# End Of MAIN #

